/* ***********************************************************
 * This file was automatically generated on 2014-03-06.      *
 *                                                           *
 * Bindings Version 2.0.0                                    *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generator git on tinkerforge.com                   *
 *************************************************************/

using System;

namespace Tinkerforge
{
	/// <summary>
	///  Device to control up to 320 RGB LEDs
	/// </summary>
	public class BrickletLEDStrip : Device
	{
		/// <summary>
		///  Used to identify this device type in
		///  <see cref="Tinkerforge.IPConnection.EnumerateCallback"/>
		/// </summary>
		public static int DEVICE_IDENTIFIER = 231;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.BrickletLEDStrip.GetResponseExpected"/>,
		///  <see cref="Tinkerforge.BrickletLEDStrip.SetResponseExpected"/> and
		///  <see cref="Tinkerforge.BrickletLEDStrip.SetResponseExpectedAll"/>.
		/// </summary>
		public const byte FUNCTION_SET_RGB_VALUES = 1;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.BrickletLEDStrip.GetResponseExpected"/>,
		///  <see cref="Tinkerforge.BrickletLEDStrip.SetResponseExpected"/> and
		///  <see cref="Tinkerforge.BrickletLEDStrip.SetResponseExpectedAll"/>.
		/// </summary>
		public const byte FUNCTION_GET_RGB_VALUES = 2;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.BrickletLEDStrip.GetResponseExpected"/>,
		///  <see cref="Tinkerforge.BrickletLEDStrip.SetResponseExpected"/> and
		///  <see cref="Tinkerforge.BrickletLEDStrip.SetResponseExpectedAll"/>.
		/// </summary>
		public const byte FUNCTION_SET_FRAME_DURATION = 3;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.BrickletLEDStrip.GetResponseExpected"/>,
		///  <see cref="Tinkerforge.BrickletLEDStrip.SetResponseExpected"/> and
		///  <see cref="Tinkerforge.BrickletLEDStrip.SetResponseExpectedAll"/>.
		/// </summary>
		public const byte FUNCTION_GET_FRAME_DURATION = 4;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.BrickletLEDStrip.GetResponseExpected"/>,
		///  <see cref="Tinkerforge.BrickletLEDStrip.SetResponseExpected"/> and
		///  <see cref="Tinkerforge.BrickletLEDStrip.SetResponseExpectedAll"/>.
		/// </summary>
		public const byte FUNCTION_GET_SUPPLY_VOLTAGE = 5;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.BrickletLEDStrip.GetResponseExpected"/>,
		///  <see cref="Tinkerforge.BrickletLEDStrip.SetResponseExpected"/> and
		///  <see cref="Tinkerforge.BrickletLEDStrip.SetResponseExpectedAll"/>.
		/// </summary>
		public const byte CALLBACK_FRAME_RENDERED = 6;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.BrickletLEDStrip.GetResponseExpected"/>,
		///  <see cref="Tinkerforge.BrickletLEDStrip.SetResponseExpected"/> and
		///  <see cref="Tinkerforge.BrickletLEDStrip.SetResponseExpectedAll"/>.
		/// </summary>
		public const byte FUNCTION_SET_CLOCK_FREQUENCY = 7;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.BrickletLEDStrip.GetResponseExpected"/>,
		///  <see cref="Tinkerforge.BrickletLEDStrip.SetResponseExpected"/> and
		///  <see cref="Tinkerforge.BrickletLEDStrip.SetResponseExpectedAll"/>.
		/// </summary>
		public const byte FUNCTION_GET_CLOCK_FREQUENCY = 8;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.BrickletLEDStrip.GetResponseExpected"/>,
		///  <see cref="Tinkerforge.BrickletLEDStrip.SetResponseExpected"/> and
		///  <see cref="Tinkerforge.BrickletLEDStrip.SetResponseExpectedAll"/>.
		/// </summary>
		public const byte FUNCTION_GET_IDENTITY = 255;



		/// <summary>
		///  This callback is triggered directly after a new frame is rendered.
		///  
		///  You should send the data for the next frame directly after this callback
		///  was triggered.
		///  
		///  For an explanation of the general approach see <see cref="Tinkerforge.BrickletLEDStrip.SetRGBValues"/>.
		/// </summary>
		public event FrameRenderedEventHandler FrameRendered;
		/// <summary>
		/// </summary>
		public delegate void FrameRenderedEventHandler(BrickletLEDStrip sender, int length);

		/// <summary>
		///  Creates an object with the unique device ID <c>uid</c> and adds  it to
		///  the IPConnection <c>ipcon</c>.
		/// </summary>
		public BrickletLEDStrip(string uid, IPConnection ipcon) : base(uid, ipcon)
		{
			this.apiVersion[0] = 2;
			this.apiVersion[1] = 0;
			this.apiVersion[2] = 1;
			callbackWrappers[CALLBACK_FRAME_RENDERED] = new CallbackWrapper(OnFrameRendered);

			responseExpected[FUNCTION_SET_RGB_VALUES] = ResponseExpectedFlag.FALSE;
			responseExpected[FUNCTION_GET_RGB_VALUES] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[FUNCTION_SET_FRAME_DURATION] = ResponseExpectedFlag.FALSE;
			responseExpected[FUNCTION_GET_FRAME_DURATION] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[FUNCTION_GET_SUPPLY_VOLTAGE] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[FUNCTION_SET_CLOCK_FREQUENCY] = ResponseExpectedFlag.FALSE;
			responseExpected[FUNCTION_GET_CLOCK_FREQUENCY] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[FUNCTION_GET_IDENTITY] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[CALLBACK_FRAME_RENDERED] = ResponseExpectedFlag.ALWAYS_FALSE;
		}

		/// <summary>
		///  Sets the *rgb* values for the LEDs with the given *length* starting 
		///  from *index*.
		///  
		///  The maximum length is 16, the index goes from 0 to 319 and the rgb values
		///  have 8 bits each.
		///  
		///  Example: If you set
		///  
		///  * index to 5,
		///  * length to 3,
		///  * r to [255, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0],
		///  * g to [0, 255, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0] and
		///  * b to [0, 0, 255, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]
		///  
		///  the LED with index 5 will be red, 6 will be green and 7 will be blue.
		///  
		///  .. note:: Depending on the LED circuitry colors can be permuted.
		///  
		///  The colors will be transfered to actual LEDs when the next
		///  frame duration ends, see <see cref="Tinkerforge.BrickletLEDStrip.SetFrameDuration"/>.
		///  
		///  Generic approach: 
		///  
		///  * Set the frame duration to a value that represents
		///    the number of frames per second you want to achieve. 
		///  * Set all of the LED colors for one frame.
		///  * Wait for the <see cref="Tinkerforge.BrickletLEDStrip.FrameRendered"/> callback.
		///  * Set all of the LED colors for next frame.
		///  * Wait for the <see cref="Tinkerforge.BrickletLEDStrip.FrameRendered"/> callback.
		///  * and so on.
		///  
		///  This approach ensures that you can change the LED colors with
		///  a fixed frame rate.
		///  
		///  The actual number of controllable LEDs depends on the number of free
		///  Bricklet ports. See :ref:`here &lt;led_strip_bricklet_ram_constraints&gt;` for more
		///  information. A call of <see cref="Tinkerforge.BrickletLEDStrip.SetRGBValues"/> with index + length above the
		///  bounds is ignored completely.
		/// </summary>
		public void SetRGBValues(int index, byte length, byte[] r, byte[] g, byte[] b)
		{
			byte[] request = CreateRequestPacket(59, FUNCTION_SET_RGB_VALUES);
			LEConverter.To((short)index, 8, request);
			LEConverter.To((byte)length, 10, request);
			LEConverter.To((byte[])r, 11, 16, request);
			LEConverter.To((byte[])g, 27, 16, request);
			LEConverter.To((byte[])b, 43, 16, request);

			SendRequest(request);

		}

		/// <summary>
		///  Returns the rgb with the given *length* starting from the
		///  given *index*.
		///  
		///  The values are the last values that were set by <see cref="Tinkerforge.BrickletLEDStrip.SetRGBValues"/>.
		/// </summary>
		public void GetRGBValues(int index, byte length, out byte[] r, out byte[] g, out byte[] b)
		{
			byte[] request = CreateRequestPacket(11, FUNCTION_GET_RGB_VALUES);
			LEConverter.To((short)index, 8, request);
			LEConverter.To((byte)length, 10, request);

			byte[] response = SendRequest(request);

			r = LEConverter.ByteArrayFrom(8, response, 16);
			g = LEConverter.ByteArrayFrom(24, response, 16);
			b = LEConverter.ByteArrayFrom(40, response, 16);
		}

		/// <summary>
		///  Sets the frame duration in ms.
		///  
		///  Example: If you want to achieve 20 frames per second, you should
		///  set the frame duration to 50ms (50ms * 20 = 1 second). 
		///  
		///  For an explanation of the general approach see <see cref="Tinkerforge.BrickletLEDStrip.SetRGBValues"/>.
		///  
		///  Default value: 100ms (10 frames per second).
		/// </summary>
		public void SetFrameDuration(int duration)
		{
			byte[] request = CreateRequestPacket(10, FUNCTION_SET_FRAME_DURATION);
			LEConverter.To((short)duration, 8, request);

			SendRequest(request);

		}

		/// <summary>
		///  Returns the frame duration as set by <see cref="Tinkerforge.BrickletLEDStrip.SetFrameDuration"/>.
		/// </summary>
		public int GetFrameDuration()
		{
			byte[] request = CreateRequestPacket(8, FUNCTION_GET_FRAME_DURATION);

			byte[] response = SendRequest(request);

			return LEConverter.UShortFrom(8, response);
		}

		/// <summary>
		///  Returns the current supply voltage of the LEDs. The voltage is given in mV.
		/// </summary>
		public int GetSupplyVoltage()
		{
			byte[] request = CreateRequestPacket(8, FUNCTION_GET_SUPPLY_VOLTAGE);

			byte[] response = SendRequest(request);

			return LEConverter.UShortFrom(8, response);
		}

		/// <summary>
		///  Sets the frequency of the clock in Hz. The range is 10000Hz (10kHz) up to
		///  2000000Hz (2MHz).
		///  
		///  The Bricklet will choose the nearest achievable frequency, which may
		///  be off by a few Hz. You can get the exact frequency that is used by
		///  calling <see cref="Tinkerforge.BrickletLEDStrip.GetClockFrequency"/>.
		///  
		///  If you have problems with flickering LEDs, they may be bits flipping. You
		///  can fix this by either making the connection between the LEDs and the
		///  Bricklet shorter or by reducing the frequency.
		///  
		///  With a decreasing frequency your maximum frames per second will decrease
		///  too.
		///  
		///  The default value is 1.66MHz.
		///  
		///  <note>
		///   The frequency in firmware version 2.0.0 is fixed at 2MHz.
		///  </note>
		///  
		///  .. versionadded:: 2.0.1~(Plugin)
		/// </summary>
		public void SetClockFrequency(long frequency)
		{
			byte[] request = CreateRequestPacket(12, FUNCTION_SET_CLOCK_FREQUENCY);
			LEConverter.To((int)frequency, 8, request);

			SendRequest(request);

		}

		/// <summary>
		///  Returns the currently used clock frequency.
		///  
		///  .. versionadded:: 2.0.1~(Plugin)
		/// </summary>
		public long GetClockFrequency()
		{
			byte[] request = CreateRequestPacket(8, FUNCTION_GET_CLOCK_FREQUENCY);

			byte[] response = SendRequest(request);

			return LEConverter.UIntFrom(8, response);
		}

		/// <summary>
		///  Returns the UID, the UID where the Bricklet is connected to, 
		///  the position, the hardware and firmware version as well as the
		///  device identifier.
		///  
		///  The position can be 'a', 'b', 'c' or 'd'.
		///  
		///  The device identifier numbers can be found :ref:`here &lt;device_identifier&gt;`.
		///  |device_identifier_constant|
		///  
		///  .. versionadded:: 2.0.0~(Plugin)
		/// </summary>
		public override void GetIdentity(out string uid, out string connectedUid, out char position, out byte[] hardwareVersion, out byte[] firmwareVersion, out int deviceIdentifier)
		{
			byte[] request = CreateRequestPacket(8, FUNCTION_GET_IDENTITY);

			byte[] response = SendRequest(request);

			uid = LEConverter.StringFrom(8, response, 8);
			connectedUid = LEConverter.StringFrom(16, response, 8);
			position = LEConverter.CharFrom(24, response);
			hardwareVersion = LEConverter.ByteArrayFrom(25, response, 3);
			firmwareVersion = LEConverter.ByteArrayFrom(28, response, 3);
			deviceIdentifier = LEConverter.UShortFrom(31, response);
		}

		/// <summary>
		/// </summary>
		protected void OnFrameRendered(byte[] response)
		{
			int length = LEConverter.UShortFrom(8, response);

			var handler = FrameRendered;
			if(handler != null)
			{
				handler(this, length);
			}
		}
	}
}